<?php
session_start();

require_once 'db.php';

if (!isset($_SESSION['user_id'])) {
    header('Location: index.php');
    exit();
}

$user_id = $_SESSION['user_id'];

$stmt = $conn->prepare("SELECT is_admin FROM users WHERE id = ?");
$stmt->bind_param("i", $user_id);
$stmt->execute();
$result = $stmt->get_result();

if (!$result) {
    echo "Error executing the query.";
    exit();
}

$row = $result->fetch_assoc();
$is_admin = $row['is_admin'];

if ($is_admin != 1) {
    echo "<script>alert('You do not have access to this page. Maybe try asking the admin to give you access.')</script>";
    echo "<script>window.location.replace('home.php');</script>";
    exit();
}


$message = '';

if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    $file = $_FILES['file'];
    $fileName = $_FILES['file']['name'];
    $fileTmpName = $_FILES['file']['tmp_name'];
    $fileSize = $_FILES['file']['size'];
    $fileError = $_FILES['file']['error'];

    if ($fileError === 0 && $fileSize < 5000000) {
        $fileExt = strtolower(pathinfo($fileName, PATHINFO_EXTENSION));
        $fileNameSanitized = preg_replace('/[^a-zA-Z0-9\-\_\.]/', '', $fileName);
        $fileDestination = 'uploads/' . $fileNameSanitized;
        move_uploaded_file($fileTmpName, $fileDestination);

        $allowedExtensions = ['pdf', 'docx', 'doc'];
        $allowedMagicNumbers = [
            'pdf' => '25504446',
            'docx' => '504b0304',
            'doc' => 'd0cf11e0'
        ];
        $fileContent = file_get_contents($fileDestination);
        $fileMagicNumber = bin2hex(substr($fileContent, 0, 4));

        $isValidExtension = in_array($fileExt, $allowedExtensions);
        $isValidMagicNumber = isset($allowedMagicNumbers[$fileExt]) && $fileMagicNumber === $allowedMagicNumbers[$fileExt];

        usleep(500000);
        if (!$isValidExtension || !$isValidMagicNumber) {
            $message = $isValidExtension ? "Invalid file signature." : "Invalid file extension.";
            unlink($fileDestination);
        } else {
            $message = "File uploaded successfully!";
        }
    } else {
        $message = "Error uploading file due to size or upload error!";
    }
}
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>KACHOW</title>
    <link rel="stylesheet" href="../css/style.css"> 
</head>
<body>
    <nav class="navbar">
        <div class="container">
            <div class="logo">
                <a href="home.php"><img src="../assets/garbace.png" height="42" width="117" alt="Logo"></a>
            </div>
            <ul class="nav-links">
                <li><a href="home.php">Home</a></li>
                <li><a href="fileupload.php">Upload</a></li>
                <li><a href="blog.php">Blog</a></li>
                <li><a href="search.php">Search</a></li>
                <li><a href="logout.php">Logout</a></li>
            </ul>
        </div>
    </nav>
    <div class="form-container">
        <h1>File Upload Page</h1>
        <form action="fileupload.php" method="post" enctype="multipart/form-data">
            <div class="form-group">
                <label for="file">Choose a document to upload:</label>
                <input type="file" name="file" id="file" accept=".pdf, .docx, .doc">
                <label for="file"></br>Allowed File Types: docx, doc, pdf</label>
            </div>
            <br>
            <div class="form-group">
                <button type="submit" name="submit">Upload</button>
            </div>
            <?php if ($message): ?>
                <div class="<?php echo strpos($message, 'successfully') !== false ? 'upload-success' : 'error'; ?>">
                    <?php echo $message; ?>
                </div>
            <?php endif; ?>
        </form>
        <div class="back-home">
            <form action="home.php" method="GET">
                <button type="submit" class="back-home-button">&laquo; Back</button>
            </form>
        </div>
    </div>
</body>
</html>
