<?php
// Include the database connection file
require 'db.php';

// Check if the form is submitted
if ($_SERVER["REQUEST_METHOD"] == "POST" && isset($_POST['register'])) {
    // Get the form data and sanitize them
    $fullname = trim($_POST['fullname']);
    $username = trim($_POST['username']);
    $password = trim($_POST['password']);

    // Input validation
    if (empty($fullname) || empty($username) || empty($password)) {
        echo "<script>alert('All fields are required.');</script>";
    } elseif (!preg_match('/^[a-zA-Z\s]{1,50}$/', $fullname)) {
        echo "<script>alert('Full name must only contain letters and spaces, and must be 50 characters or less.');</script>";
    } elseif (preg_match('/[\/:*?"<>|]/', $username)) {
        echo "<script>alert('Username cannot contain any of the following characters: \\/:*?\"<>|');</script>";
    } else {
        // Hash the password using md5
        $hashedPassword = md5($password);

        // Check if the username already exists
        $stmtCheck = $conn->prepare("SELECT * FROM users WHERE username = ?");
        $stmtCheck->execute([$username]);
        $userExists = $stmtCheck->fetch();

        if ($userExists) {
            echo "<script>alert('Username already exists. Please choose another.');</script>";
        } else {
            // Insert new user into the database
            $stmtInsert = $conn->prepare("INSERT INTO users (username, password, full_name) VALUES (?, ?, ?)");
            if ($stmtInsert->execute([$username, $hashedPassword, $fullname])) {
                echo "<script>alert('Registration successful!');</script>";
                header("Location: index.php");
                exit;
            } else {
                echo "<script>alert('There was an error registering your account.');</script>";
            }
        }
    }
}
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>KACHOW</title>
    <link rel="stylesheet" href="../css/style.css">
</head>
<body>
    <div class="form-container">
        <h1>SIGN UP</h1>
        <form action="register.php" method="POST">
            <div class="form-group">
                <input type="text" id="fullname" name="fullname" placeholder="Full Name" required>
            </div>
            <div class="form-group">
                <input type="text" id="username" name="username" placeholder="Username" required>
            </div>
            <div class="form-group">
                <input type="password" id="password" name="password" placeholder="Password" required>
            </div>
            <div class="form-group">
                <button type="submit" name="register">REGISTER</button>
            </div>
        </form>
        <br>
        <div>
            Already have an account? <a href="index.php">Login here</a>.
        </div>
    </div>
    <div class="back-home">
        <form action="/" method="GET">
            <button type="submit" class="back-home-button">&laquo; Back</button>
        </form>
    </div>
</body>
</html>
