<?php
require 'db.php';

session_start();

if (!isset($_SESSION['user_id'])) {
    header('Location: index.php');
    exit();
}

$searchResults = '';
$keywords = ['union', 'UNION', 'select', 'SELECT', 'from', 'FROM', 'and', 'AND', 'like', 'LIKE', '*', '/'];

function check_WAF($data, $keywords) {
    foreach ($keywords as $keyword) {
        if (strpos($data, $keyword) !== false) { 
            return true; 
        }
    }
    return false; 
}

if ($_SERVER["REQUEST_METHOD"] == "POST" && isset($_POST['search'])) {
    $searchTerm = $_POST['searchTerm'];

    if (check_WAF($searchTerm, $keywords)) {
        $searchResults = "<p class='error'>Your search term contains forbidden characters or keywords.</p>";
    } else {
        $sql = "SELECT username, full_name FROM users WHERE full_name LIKE '%$searchTerm%' OR username LIKE '%$searchTerm%'";
        $result = $conn->query($sql);

        if ($result->num_rows > 0) {
            $searchResults .= "<div class='user-list'>";
            while ($row = $result->fetch_assoc()) {
                $searchResults .= "<div class='user-item'>";
                $searchResults .= "<p><strong>Full Name:</strong> " . htmlspecialchars($row['full_name']) . "</p>";
                $searchResults .= "<p><strong>Username:</strong> " . htmlspecialchars($row['username']) . "</p>";
                $searchResults .= "</div>";
                $searchResults .= "</br>";
            }
            $searchResults .= "</div>";
        } else {
            $searchResults = "<p class='no-results'>No results found.</p>";
        }
    }
}
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>KACHOW</title>
    <link rel="stylesheet" href="../css/style.css">
    <style>
        .result-container {
            max-height: 300px;
            overflow-y: auto;
        }
    </style>
</head>
<body>
    <nav class="navbar">
        <div class="container">
            <div class="logo">
                <a href="home.php"><img src="../assets/garbace.png" height="42" width="117" alt="Logo"></a>
            </div>
            <ul class="nav-links">
                <li><a href="home.php">Home</a></li>
                <li><a href="fileupload.php">Upload</a></li>
                <li><a href="blog.php">Blog</a></li>
                <li><a href="search.php">Search</a></li>
                <li><a href="logout.php">Logout</a></li>
            </ul>
        </div>
    </nav>  
    <div class="form-container">
        <h1>Search Users</h1>
        <form action="search.php" method="POST">
            <div class="form-group">
                <input type="text" id="searchTerm" name="searchTerm" placeholder="Search by name or username" required>
                </br>
                <button type="submit" name="search">SEARCH</button>
            </div>
        </form>
        <div class="result-container scroll">
            <?php echo $searchResults; ?>
        </div>
    </div>
    <div class="back-home">
        <form action="home.php" method="GET">
            <button type="submit" class="back-home-button">&laquo; Back</button>
        </form>
    </div>
</body>
</html>
